import java.util.ArrayList;


public class TestMt5 {
	private static class Allocator implements Runnable {
		private String id;
		
		Allocator(String id) {
			this.id = id;
		}
		
		public void run() {
            long start = System.currentTimeMillis();
			ArrayList list = new ArrayList();
			int count = 0;
			for (int i = 0;; i++) {
				Object[] data = new Object[1024 / 24];
				for (int j = 0; j < data.length; j++)
					data[j] = new Object();

				list.add(data);
				if (i % 100000 == 0) {
					long delta = System.currentTimeMillis() - start;
					System.out.println(id + "\t" + count + "\t" + delta);
					count++;
					list.clear();
					if (count > 1000)
						break;
				}
			}
		}
	}
	
	public static void main(String[] args) {
		for (int i=0; i<10; i++)
			new Thread(new Allocator(""+i)).start();
	}
}

